<?php

declare(strict_types=1);

namespace DoctrineMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220308134103 extends AbstractMigration
{
    public function getDescription() : string
    {
        return '';
    }

    public function up(Schema $schema) : void
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'sqlite', 'Migration can only be executed safely on \'sqlite\'.');

        $this->addSql('DROP INDEX IDX_232B318C1AD5CDBF');
        $this->addSql('DROP INDEX IDX_232B318CF1849495');
        $this->addSql('DROP INDEX IDX_232B318C446F285F');
        $this->addSql('CREATE TEMPORARY TABLE __temp__game AS SELECT id, players_id, studio_id, cart_id, name, price, year FROM game');
        $this->addSql('DROP TABLE game');
        $this->addSql('CREATE TABLE game (id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, players_id INTEGER DEFAULT NULL, studio_id INTEGER DEFAULT NULL, cart_id INTEGER DEFAULT NULL, name VARCHAR(255) NOT NULL COLLATE BINARY, price DOUBLE PRECISION NOT NULL, year DATE NOT NULL, CONSTRAINT FK_232B318CF1849495 FOREIGN KEY (players_id) REFERENCES players (id) NOT DEFERRABLE INITIALLY IMMEDIATE, CONSTRAINT FK_232B318C446F285F FOREIGN KEY (studio_id) REFERENCES studio (id) NOT DEFERRABLE INITIALLY IMMEDIATE, CONSTRAINT FK_232B318C1AD5CDBF FOREIGN KEY (cart_id) REFERENCES cart (id) NOT DEFERRABLE INITIALLY IMMEDIATE)');
        $this->addSql('INSERT INTO game (id, players_id, studio_id, cart_id, name, price, year) SELECT id, players_id, studio_id, cart_id, name, price, year FROM __temp__game');
        $this->addSql('DROP TABLE __temp__game');
        $this->addSql('CREATE INDEX IDX_232B318C1AD5CDBF ON game (cart_id)');
        $this->addSql('CREATE INDEX IDX_232B318CF1849495 ON game (players_id)');
        $this->addSql('CREATE INDEX IDX_232B318C446F285F ON game (studio_id)');
        $this->addSql('DROP INDEX IDX_AD08E6E7E48FD905');
        $this->addSql('DROP INDEX IDX_AD08E6E712469DE2');
        $this->addSql('CREATE TEMPORARY TABLE __temp__game_category AS SELECT game_id, category_id FROM game_category');
        $this->addSql('DROP TABLE game_category');
        $this->addSql('CREATE TABLE game_category (game_id INTEGER NOT NULL, category_id INTEGER NOT NULL, PRIMARY KEY(game_id, category_id), CONSTRAINT FK_AD08E6E7E48FD905 FOREIGN KEY (game_id) REFERENCES game (id) ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE, CONSTRAINT FK_AD08E6E712469DE2 FOREIGN KEY (category_id) REFERENCES category (id) ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE)');
        $this->addSql('INSERT INTO game_category (game_id, category_id) SELECT game_id, category_id FROM __temp__game_category');
        $this->addSql('DROP TABLE __temp__game_category');
        $this->addSql('CREATE INDEX IDX_AD08E6E7E48FD905 ON game_category (game_id)');
        $this->addSql('CREATE INDEX IDX_AD08E6E712469DE2 ON game_category (category_id)');
    }

    public function down(Schema $schema) : void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'sqlite', 'Migration can only be executed safely on \'sqlite\'.');

        $this->addSql('DROP INDEX IDX_232B318CF1849495');
        $this->addSql('DROP INDEX IDX_232B318C446F285F');
        $this->addSql('DROP INDEX IDX_232B318C1AD5CDBF');
        $this->addSql('CREATE TEMPORARY TABLE __temp__game AS SELECT id, players_id, studio_id, cart_id, name, price, year FROM game');
        $this->addSql('DROP TABLE game');
        $this->addSql('CREATE TABLE game (id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, players_id INTEGER DEFAULT NULL, studio_id INTEGER DEFAULT NULL, cart_id INTEGER DEFAULT NULL, name VARCHAR(255) NOT NULL, price DOUBLE PRECISION NOT NULL, year DATE NOT NULL)');
        $this->addSql('INSERT INTO game (id, players_id, studio_id, cart_id, name, price, year) SELECT id, players_id, studio_id, cart_id, name, price, year FROM __temp__game');
        $this->addSql('DROP TABLE __temp__game');
        $this->addSql('CREATE INDEX IDX_232B318CF1849495 ON game (players_id)');
        $this->addSql('CREATE INDEX IDX_232B318C446F285F ON game (studio_id)');
        $this->addSql('CREATE INDEX IDX_232B318C1AD5CDBF ON game (cart_id)');
        $this->addSql('DROP INDEX IDX_AD08E6E7E48FD905');
        $this->addSql('DROP INDEX IDX_AD08E6E712469DE2');
        $this->addSql('CREATE TEMPORARY TABLE __temp__game_category AS SELECT game_id, category_id FROM game_category');
        $this->addSql('DROP TABLE game_category');
        $this->addSql('CREATE TABLE game_category (game_id INTEGER NOT NULL, category_id INTEGER NOT NULL, PRIMARY KEY(game_id, category_id))');
        $this->addSql('INSERT INTO game_category (game_id, category_id) SELECT game_id, category_id FROM __temp__game_category');
        $this->addSql('DROP TABLE __temp__game_category');
        $this->addSql('CREATE INDEX IDX_AD08E6E7E48FD905 ON game_category (game_id)');
        $this->addSql('CREATE INDEX IDX_AD08E6E712469DE2 ON game_category (category_id)');
    }
}
