<?php

namespace App\Entity;

use App\Repository\PlayersRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PlayersRepository::class)
 */
class Players
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $number;

    /**
     * @ORM\OneToMany(targetEntity=Game::class, mappedBy="players")
     */
    private $studio;

    public function __construct()
    {
        $this->studio = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNumber(): ?string
    {
        return $this->number;
    }

    public function setNumber(string $number): self
    {
        $this->number = $number;

        return $this;
    }

    /**
     * @return Collection<int, Game>
     */
    public function getGames(): Collection
    {
        return $this->games;
    }

    public function addStudio(Game $games): self
    {
        if (!$this->$games->contains($games)) {
            $this->$games[] = $games;
            $games->setPlayers($games);
        }

        return $this;
    }

    public function removeStudio(Game $games): self
    {
        if ($this->games->removeElement($games)) {
            // set the owning side to null (unless already changed)
            if ($games->getPlayers() === $this) {
                $games->setPlayers(null);
            }
        }

        return $this;
    }
}
