<?php

namespace App\Form;

use App\Entity\Category;
use App\Entity\Game;
use App\Entity\Players;
use App\Entity\Studio;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\DateType;

class GameType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('name',TextType::class, [
                'label' => 'Nom'
            ])
            ->add('price',TextType::class, [
                'label' => 'Prix'
            ])
            ->add('year' ,DateType::class, [
                'label' => 'Année de sortie'
            ])
            ->add('category', EntityType::class, [
                'class' => Category::class,
                'choice_label' => 'name',
                'expanded' => true,
                'multiple' => true
            ])
            ->add('players', EntityType::class, [
                'class' => Players::class,
                'expanded' => true,
                'choice_label' => 'number'
            ])
            ->add('studio', EntityType::class, [
                'class' => Studio::class,
                'choice_label' => 'name'
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Game::class,
        ]);
    }
}
